!----------------------------------------------------------
! Anes 20XE :      GNUmake & Fortran 90
!----------------------------------------------------------
!         : 1.00
!          : VIA
!----------------------------------------------------------
!  VIA 20.09.10 :  - 
!  VIA 20.10.09 :      *.MOD
!                  GFORTRAN - mod       
!  VIA 10.10.08 :     gnumake   
!  VIA 12.10.09 :     -@c:< >
!  VIA 06.05.08 : 
! =========================================================
! 10.02.11: :       mod ( 
!           ) .     !
!----------------------------------------------------------

module depDATA
!========================================
!      
!-
!#### VIA 29.11.10: ,  auTOOLS::InitUtil  
! character(*), parameter :: mOS = 'lunix'
! character(*), parameter :: mOS = 'win'
!-
!========================================

 character (256) SourceDir, DepFile, SourceDir_win, SourceDir_lunix
 integer, parameter:: MAX_FILES = 500
! ----    ---- 
 character (64) ForFiles(MAX_FILES)
 character (8) ExtFiles(MAX_FILES)
 integer:: NoForFiles = 0
 integer NoModuleInFile(MAX_FILES)
!------ 
 character (64) ModNames(MAX_FILES)  !   "" MODULE <>
 integer :: NoModNames = 0
 integer IndModFiles(MAX_FILES)      !   ForFiles(),   
!------
 integer NoCompCom
 character (128) CompCom(60)  
 
 integer, parameter:: LU_IN = 50, LU_DBG=66, LU_OUT = 51, LU_TMP = 52
 character (256) InStr, CurFName
!-----
 logical (1) MapF2M(MAX_FILES,MAX_FILES)
! VIA 10.09 :  
 character(32) N_OBJ, N_MOD
 character(1) PathDelim
!-----
 CONTAINS
!-----
 
!-------------------------------------------------     
!       NoExeArg
!-------------------------------------------------
integer function NoExeArg()
!---------
!OS DEPEND:     
!
   NoExeARG = COMMAND_ARGUMENT_COUNT()
!  NoExeArg = NARGS() - 1
end function

!-------------------------------------------------     
!       GetExeArg
!-------------------------------------------------
character (128) function GetExeArg(IARG) Result(str)
!---------
!OS DEPEND:     
! IARG -   1
!-----------
 str = ' '
 if(IARG.GT. NoExeARG()) return
! CALL GETARG(IARG, str)
 CALL GET_COMMAND_ARGUMENT(iARG, Str)
end function 

!-------------------------------------------------     
!       ReplaceChar
!-------------------------------------------------
subroutine ReplaceChar(str,cIn,cOut)
 character(*) str
 character(1) cIn,cOut
!-----  
  Len = LEN_TRIM(str)
  if(Len.EQ.0) return
  do i=1,Len
    if(str(i:i).EQ.cIn) str(i:i) = cOut
  end do
end subroutine

end module


!================================================
!    aDepF90
!================================================
Program aDepf90
 USE depDATA
 USE auTOOLS 
!------------------------------------------------
!  :
!  adepf90 -sc:<   *.f*> -df:< >
!          -@c:<CompCom>             
!       :
!  1)    MODULE ::
!
!  $(obj_dir)/<F->.obj $(mod_dir)/<Mod->.mod : $(src_dir)/<F->.fXX < .mod>
!  <tab>  <>
!
!  2)    MODULE,    ::
! 
!  $(obj_dir)/<F->.obj: $(src_dir)/<F->.fXX < .mod>
! 
!  10.10.08 :  Mod ,   
!------------------------------------------------
  call InitUtil
!==============
! 1)     
!
  CALL ArgProg

!==============
! 2)   
!
  CALL GetFiles

!==============
! 3)       mod
!
! VIA 11.01.13:    
 LU = LU_IN 

 NoModNames = 0
 do IFF=1,NoForFiles
   CurFName = TRim(SourceDir)//TRim(ForFiles(IFF))//Trim(ExtFiles(IFF))
   OPEN(LU, FILE=CurFName,STATUS='old',ERR=100)
   do while(.TRUE.)
     read(LU,'(a256)',ERR=200 ,END=200 ) INstr
     CALL SetModuleOper(IFF)
   enddo
200 CLOSE(LU)
 end do
!==============
! 4)  MapM2F
!
 MapF2M = .FALSE.
 do IFF=1,NoForFiles
   CurFName = TRim(SourceDir)//TRim(ForFiles(IFF))//Trim(ExtFiles(IFF))
   OPEN(LU, FILE=CurFName,STATUS='old',ERR=100)
   do while(.TRUE.)
     read(LU,'(a256)',ERR=300 ,END=300 ) INstr
     CALL SetUseOper(IFF)
   enddo
300 CLOSE(LU)
 end do
!==============
! 5)  DepFile
!
 CALL CReateDEpFile_FX_Coudert

!==============
!  
!

 !CALL PrintDebug
 stop
    
!------------     
100 CONTINUE
    write(*,*) 'adepf90 error: Invalid file: '//TRim(CurFName)
    stop 
end program

!================================================
!    AgrProg
!================================================
subroutine argProg
 USE depDATA
 USE auTOOLS
 character (80) keys
!-----
NoARG = NoExeArg() !      
if(NoARG.EQ.0) then
  write(*,*) ' adepf90: command line:'
  write(*,*) '  adepf90.exe -sd:<src_dir> [-df:<depFile>] [-@c:"<CompileCommand>"] [-o:obj] [-m:mod] [-pd:/]'
  STOP
endif
SourceDir = ''
DepFile   = 'depf90.adep'

NoCompCom = 1
CompCom(1:60) = ' '
CompCom(1) = '@$(for) $(for_opt) $<'

N_OBJ = 'obj'
N_MOD = 'mod'
PathDelim = '/'
if(OS.EQ.'win') PathDelim = '\'
DO IK = 1, NoArg
  keys = GetExeArg(IK)
  call toLOWER(keys)
  if(keys(1:1).EQ.'/') keys(1:1) = '-'
  if(keys(1:1).EQ.'-') then ! 
    if(keys(2:4).EQ.'sd:') then
       SourceDir = keys(5:)
    endif
    if(keys(2:4).EQ.'df:') then
       DepFile = keys(5:)
    endif
    if(keys(2:3).EQ.'c:') then
       CompCom = keys(4:)
       NoCompCom=1
    endif
    if(keys(2:3).EQ.'o:') then
       N_OBJ = keys(4:)
    endif
    if(keys(2:3).EQ.'m:') then
       N_MOD = keys(4:)
    endif
    if(keys(2:4).EQ.'pd:') then
       PathDelim = keys(5:5)
       iF(PathDelim.NE.'/'.AND.PathDelim.NE.'\') PathDelim='\'
    endif
    if(keys(2:4).EQ.'@c:') then
       call LoadCom(keys(5:))
    endif
  endif
enddo
ll = len_trim(SourceDir)
if(ll.GT.1) then
  if(SourceDir(ll:ll).NE.'\'.AND.SourceDir(ll:ll).NE.'/') SourceDir(ll+1:ll+1) =PathDelim
endif
SourceDir_win = SourceDir
call ReplaceChar(SourceDir_win,'/','\')
SourceDir_lunix = SourceDir
call ReplaceChar(SourceDir_lunix,'\','/')

write(*,*)   'adepf90: Anes Fortran 90 Dependent utility, ver. 1.3'
write(*,*)   ' SourceDir:"',TRim(SourceDir),'"'
write(*,*)   ' DepFile  :"',TRim(DepFile),'"'
if(NoCompCom.EQ.1) then
  write(*,*) '   Compile:"',TRim(CompCom(1)),'"'
else
  write(*,*) '   Compile:'
  do I=1,NoCompCom
    write(*,*) '     "'//TRim(CompCom(I)),'"'
  enddo
endif  
write(*,*)   ' PathDelim:"',PathDelim,'"'
end subroutine 

!================================================
!    GetFiles
!================================================
!>subroutine GetFiles
!> USE depDATA
! !>USE DFPORT
!-----
!> INTEGER  Handle ,rc
!> Type (FILE$INFO) fi
!> character (64)   nStr
!> character (256)  wStr
!-----
!>   lExt = len_trim(ExtFile)
!>   wStr = TRIM(SourceDir) // '*'//TRim(ExtFile)
!>   NoForFiles = 0
!---
!>   Handle = FILE$FIRST
!>   do WHILE(.TRUE.)
!>      rc = GetFileInfoQQ(wStr , fi, Handle )
!>      if( Handle .EQ. FILE$LAST )  exit
!>      if(Handle .EQ. FILE$ERROR) then
!>        write(*,*) ' Error: Invalid file or path name'
!>        stop
!>      endif
!>      if(IAND(fi.PERMIT , FILE$DIR) .EQ. 0) then
!>        nStr = fi.name
!>        call toLOWER(nStr)
!>        lName = len_trim(nStr)
!>        NoForFiles = NoForFiles+1
!>        ForFiles(NoForFiles)=  nStr(1:lName-lExt) !   
!         write(*,*) '>',TRim(fi.name),'<'
!>      end if
!>    end do
!>    if(NoForFiles .EQ. 0) then
!>      write(*,*) ' Error: in source directory file not found'
!>      stop
!>    endif
!>    NoModuleInFile(1:MAX_FILES) = 0
!>   
!>end subroutine 

!================================================
!    GetFiles - - 
!================================================
subroutine GetFiles
 USE depDATA
 USE auTOOLS
!-----
 character(*), parameter:: tmpFILE = '12345678._tmp'
 character (256)  wStr
 character(4) tExt
!-----
  NoForFiles = 0
!---
  if(OS.EQ.'win') then
    wStr = TRIM(SourceDir_win)// '*.f*'
    CALL system('dir /b '//TRIM(wStr)//'> '//trim(tmpFILE))
  else
    wStr = TRIM(SourceDir_lunix)// '*.f*'
    CALL system('ls -1 '//TRIM(wStr)//'> '//trim(tmpFILE))
  endif
  OPEN(LU_TMP, FILE = tmpFILE ,STATUS='old',ERR=100)
  do WHILE(.TRUE.)
    READ(LU_TMP,'(A)',END=200) wStr
    iP = index(wStr,'.',back=.true.)
! ----    ----
    tExt =  wStr(iP:)
    CALL toLOWER(InStr)
    if(tExt.EQ.'.for'.OR. &
       tExt.EQ.'.f  '.OR. &
       tExt.EQ.'.f90'.OR. &
       tExt.EQ.'.f95') then
       NoForFiles = NoForFiles+1
! VIA 15.01.11:  ls     .   !
       if(OS.EQ.'win') then
          ForFiles(NoForFiles)=  wStr(1:iP-1) !    "" 
          ExtFiles(NoForFiles)=  wStr(iP:)  !    
       else
          lenPPP = len_trim(SourceDir_lunix)
          ForFiles(NoForFiles)=  wStr(lenPPP+1:iP-1) !    "" 
          ExtFiles(NoForFiles)=  wStr(iP:)  !    
       endif
    endif  
  end do
200 CLOSE(LU_TMP , STATUS='delete') 
!-----
  NoModuleInFile(1:MAX_FILES) = 0
  if(NoForFiles .NE. 0) return
!-----
100 continue
    write(*,*) 'adepf90 error: Not found in source directory fortran files'
    stop
end subroutine 


!================================================
!    SetModuleOper
!================================================
SUBROUTINE SetModuleOper(IFF)
 USE depDATA
 USE auTOOLS
 character (64) MName
!------
 CALL toLOWER(InStr)
 ich = Index(InStr,'!')
 if(ich.EQ.1) return
 if(ich.GT.1) InStr = InStr(1:ich-1) 
 INstr = ADJUSTL(INstr)
 if(InStr(1:6).NE.'module') return
 InStr = ADJUSTL(InStr(7:))
 ich = Index(InStr,' ')
 MName = TRim(InStr(1:ich-1))
!---  
! ? module procedure
 if(Trim(MName).EQ.'procedure') return
!-----
 if(NoModNames.NE.0) then
   DO M = 1,NoModNames
     if(TRIM(MName).EQ.TRim(ModNames(M))) then
! VIA 08.08.13:   amrfun.f90    Module, 
!     .    -.
!
        if(TRim(ForFiles(IndModFiles(M))).NE.TRim(ForFiles(IFF))) then
           write(*,*) 'adepf90 error: Dublicate module definition:"'//TRim(ModNames(M))//'"'
           write(*,*) '  Source1: "'//TRim(ForFiles(IndModFiles(M)))//TRim(ExtFiles(M))//'"' 
           write(*,*) '  Source2: "'//TRim(ForFiles(IFF))//TRim(ExtFiles(M))//'"' 
           stop
        else
           return  !   ,  .
        endif          
     endif
   endDO  
 endif
 NoModNames = NoModNames+1
 IndModFiles(NoModNames) = IFF
 ModNames(NoModNames) = MName
 
 NoModuleInFile(IFF) = NoModuleInFile(IFF) + 1
end subroutine

!================================================
!    SetUseOper
!================================================
SUBROUTINE SetUseOper(IFF)
 USE depDATA
 USE auTOOLS
 character (64) MName
!------
 CALL toLOWER(InStr)
 ich = Index(InStr,'!')
 if(ich.EQ.1) return
 if(ich.GT.1) InStr = InStr(1:ich-1) 
 INstr = ADJUSTL(INstr)
 if(InStr(1:3).NE.'use') return
!------ 
 InStr = ADJUSTL(InStr(4:))
 ich = Index(InStr,' ')
 MName = TRim(InStr(1:ich-1))
!   ONLY     :    use coDATA, only: ...
 k = Index(MName,','); if(K.NE.0) MName = MName(1:k-1)  

!---   
!
 IMM = 0
 if(NoModNames.NE.0) then
   DO M = 1,NoModNames
     if(TRIM(MName).EQ.TRim(ModNames(M))) then
        IMM = M
        Exit
     endif
   enddo  
 endif
 if(IMM.EQ.0) return   !   USE
!   ,  MODULE    .
!      !
! 
 !MapF2M(IFF,IMM) =.TRUE.
 IFF_MOD = IndModFiles(IMM)
 if(IFF_MOD.NE.IFF) MapF2M(IFF,IMM) =.TRUE.
 
 NoModuleInFile(IFF) = 666   !   USE 
end subroutine




!================================================
!    PrintDebug
!================================================
SUBROUTINE PrintDebug
 USE depDATA
!------
  write(LU_DBG,*) '=== Source Files ======'
  write(LU_DBG,*) '  NoFiles =', NoForFiles
  write(LU_DBG,*) '  SourceDir ="'//TRim(SourceDir)//'"'
  if(NoForFiles.NE.0) then
    do I = 1, NoForFiles
       write(LU_DBG,*) I, '  "'//TRim(ForFiles(I))//'"'
    enddo 
  endif
  write(LU_DBG,'(/a)') '=== Module Files ======'
  write(LU_DBG,*) '  NoModule =', NoModNames
  if(NoModNames.NE.0) then
    do I = 1, NoMOdNames
      InStr = ' Mod="'//TRim(ModNames(I))//'" in "'// &
                    Trim(ForFiles(IndModFiles(I)))//'"'
       write(LU_DBG,*) I, TRim(InStr)
    enddo 
  endif
  
end subroutine 

!================================================
!    CReateDepFile_STA
!================================================
SUBROUTINE CReateDEpFile_STA
 USE depDATA
 character (512) OutStr
!------
 
 OPEN(LU_OUT, FILE = DepFile ,STATUS='UNKNOWN',ERR=100)
 write(LU_OUT,'(a)') '#============================'
 write(LU_OUT,'(a)') '# adepf90: Add GNUMake command'
 write(LU_OUT,'(a)') '#============================'
 if(NoModNames.NE.0) then
!------------
! 1)    *.mod & *.obj
!
!      MODULE    !!! (AUSER.f90)
!   -   mod+obj,  -  mod
!
   write(LU_OUT,'(a)') '# 1) *.mod & *.obj command'
   write(LU_OUT,'(a)') '#============================'
   DO IMM = 1, NoModNames 
     OutStr = '$(mod_dir)'//PathDelim//TRim(ModNames(IMM))//'.'//TRIM(n_mod)//' '
     IFF = IndModFiles(IMM)
     if(NoModuleInFile(IFF).GT.0) then
       OutStr = TRim(OutStr)//' $(obj_dir)'//PathDelim//Trim(ForFiles(IFF))//'.'//TRIM(N_obj)//' : '// &
               ' $(src_dir)'//PathDelim//Trim(ForFiles(IFF))//Trim(ExtFiles(IFF))
     else
       OutStr = TRim(OutStr)//' : '// &
               ' $(src_dir)'//PathDelim//Trim(ForFiles(IFF))//Trim(ExtFiles(IFF))
     endif          
! ----  mod  FOR  ---
     NNMOD = 0
     NLAST = 0
     DO I=1,NoModNames
       if(MapF2M(IFF,I)) then
         NNMOD = NNMOD + 1
         NLAST = I
       endif 
     ENDDO
     if(NNMOD.NE.0) OutStr = TRim(OutStr)//' \'
     write(LU_OUT,'(a)') TRim(OutStr)
     DO K = 1,NoModNames 
       if(MapF2M(IFF,K)) then
         OutStr = '        $(mod_dir)'//PathDelim//TRim(ModNames(K))//'.'//TRIM(n_mod)
         if(K.NE.NLAST) OutStr = TRim(OutStr)//' \'
         write(LU_OUT,'(a)') TRim(OutStr)
       endif  
     ENDDO
! ----   ---
    do i=1,NoCompCom
       OutStr = CHAR(9)//TRim(CompCom(i))
       write(LU_OUT,'(a)') TRim(OutStr)
    enddo   
    write(LU_OUT,*)
    
! ----   FOR : OBJ     ---
!     ForFiles(IFF)(1:3) = '***'  
     NoModuleInFile(IFF) = - NoModuleInFile(IFF)
   ENDDO
!------------
! 2)     *.obj
!
   DO IFF = 1, NoForFiles
!     if(ForFiles(IFF)(1:3).EQ.'***') cycle
     if(NoModuleInFile(IFF).LE.0) cycle
           
     OutStr = '$(obj_dir)'//PathDelim//Trim(ForFiles(IFF))//'.'//trim(n_obj)//' : '// &
               ' $(src_dir)'//PathDelim//Trim(ForFiles(IFF))//Trim(ExtFiles(IFF))
! ----  mod  FOR  ---
     NNMOD = 0
     NLAST = 0
     DO I=1,NoModNames
       if(MapF2M(IFF,I)) then
         NNMOD = NNMOD + 1
         NLAST = I
       endif 
     ENDDO
! 10.10.08 :   MOD  
     if(NNMOD.EQ.0) CYCLE
     OutStr = TRim(OutStr)//' \'
!     if(NNMOD.NE.0) OutStr = TRim(OutStr)//' \'
     write(LU_OUT,'(a)') TRim(OutStr)
     DO K = 1,NoModNames 
       if(MapF2M(IFF,K)) then
         OutStr = '        $(mod_dir)'//PathDelim//TRim(ModNames(K))//'.'//trim(n_mod)
         if(K.NE.NLAST) OutStr = TRim(OutStr)//' \'
         write(LU_OUT,'(a)') TRim(OutStr)
       endif  
     ENDDO
     ! ----   ---
! ----   ---
     do i=1,NoCompCom
        OutStr = CHAR(9)//TRim(CompCom(i))
        write(LU_OUT,'(a)') TRim(OutStr)
     enddo   
     write(LU_OUT,*)
   ENDDO
 endif 
 CLOSE(LU_OUT)
!------
 return  
100 continue
end subroutine

!================================================
!    CReateDepFile_FX_Coudert
!================================================
SUBROUTINE CReateDEpFile_FX_Coudert
 USE depDATA
 character (512) OutStr
!------
 
 OPEN(LU_OUT, FILE = DepFile ,STATUS='UNKNOWN',ERR=100)
 write(LU_OUT,'(a)') '#==============================================='
 write(LU_OUT,'(a)') '# adepf90: Add GNUMake command (FX Coudert idea)'
 write(LU_OUT,'(a)') '#==============================================='
 if(NoModNames.NE.0) then
!------------
! 1)    *.mod & *.obj
!
!      MODULE    !!! (AUSER.f90)
!   :   OBJ   
!                MOD   
!  mod+obj,  -  mod
!
   write(LU_OUT,'(a)') '# 1) *.mod command'
   write(LU_OUT,'(a)') '#============================================='
   DO IMM = 1, NoModNames 
!  ----    MOD:
!      *.mod : *.obj *.F90
!     <tab>@echo Check MOD file : ModNames(IMM)
! 
     OutStr = '$(mod_dir)'//PathDelim//TRim(ModNames(IMM))//'.'//TRIM(n_mod)//' '
     IFF = IndModFiles(IMM)
     OutStr = TRim(OutStr)//' : '// &
               ' $(src_dir)'//PathDelim//Trim(ForFiles(IFF))//Trim(ExtFiles(IFF))//' '// &
               '$(obj_dir)'//PathDelim//Trim(ForFiles(IFF))//'.'//TRIM(N_obj)  
     write(LU_OUT,'(a)') TRim(OutStr)
! ----   ---
     OutStr = CHAR(9)//'@echo Check MOD file: '//Trim(ModNames(IMM))
     write(LU_OUT,'(a)') TRim(OutStr)
     write(LU_OUT,*)
   ENDDO
!------------
! 2)     *.obj
!
   write(LU_OUT,'(a)') '#============================================='
   write(LU_OUT,'(a)') '# 2)  *.obj command'
   write(LU_OUT,'(a)') '#============================================='
   DO IFF = 1, NoForFiles
     OutStr = '$(obj_dir)'//PathDelim//Trim(ForFiles(IFF))//'.'//trim(n_obj)//' : '// &
               ' $(src_dir)'//PathDelim//Trim(ForFiles(IFF))//Trim(ExtFiles(IFF))
! ----  mod  FOR  ---
     NNMOD = 0
     NLAST = 0
     DO I=1,NoModNames
       if(MapF2M(IFF,I)) then
         NNMOD = NNMOD + 1
         NLAST = I
       endif 
     ENDDO
! 10.10.08 :   MOD  
     if(NNMOD.EQ.0) CYCLE
     OutStr = TRim(OutStr)//' \'
!     if(NNMOD.NE.0) OutStr = TRim(OutStr)//' \'
     write(LU_OUT,'(a)') TRim(OutStr)
     DO K = 1,NoModNames 
       if(MapF2M(IFF,K)) then
         OutStr = '        $(mod_dir)'//PathDelim//TRim(ModNames(K))//'.'//trim(n_mod)
         if(K.NE.NLAST) OutStr = TRim(OutStr)//' \'
         write(LU_OUT,'(a)') TRim(OutStr)
       endif  
     ENDDO
     ! ----   ---
! ----   ---
     do i=1,NoCompCom
        OutStr = CHAR(9)//TRim(CompCom(i))
        write(LU_OUT,'(a)') TRim(OutStr)
     enddo   
     write(LU_OUT,*)
   ENDDO
 endif 
 CLOSE(LU_OUT)
!------
 return  
100 continue
end subroutine




!================================================
!    LoadCom
!================================================
subroutine LoadCom(FN)
 USE depDATA
 character(*) FN
 
!-----
 LU = LU_IN
 OPEN(LU, FILE=FN,STATUS='old',ERR=100)
 NoCompCom = 0
 do while(.TRUE.)
   read(LU,'(a)',ERR=200 ,END=300 ) InStr
   NoCompCom = NoCompCom+1
   if(InStr(1:1).EQ.CHAR(9)) then
     CompCom(NoCompCom) = InStr(2:)
   else
     CompCom(NoCompCom) = InStr
   endif
 enddo
200  close(LU); return
300  close(LU); return
!300 CLOSE(LU)
 return 
100 NoCompCom = 1
 CompCom(1) = '@$(for) $(for_opt) $<'
end subroutine
